# Шахматы с Открытым Миром 1.1.1

Добро пожаловать в **Шахматы с Открытым Миром 1.1.1** – инновационную версию классической игры, обогащённую новыми механиками, бонусами, магазином и динамическим туманом войны. Погрузитесь в захватывающий мир стратегии, где каждое решение может изменить ход партии!

## Содержание

1. [Основные Правила](#основные-правила)
2. [Механики Игры](#механики-игры)
   - [Туман Войны](#туман-войны)
   - [Бонусные Поля](#бонусные-поля)
   - [Бои и HP Фигур](#бои-и-hp-фигур)
   - [Торговцы и Магазин](#торговцы-и-магазин)
3. [Механика Времени](#механика-времени)
4. [Процедурная Генерация Бонусов](#процедурная-генерация-бонусов)
5. [Баланс Фигур](#баланс-фигур)
6. [Обновления и Изменения](#обновления-и-изменения)

---

## Основные Правила

**Шахматы с Открытым Миром** сохраняют основные принципы классической шахматной игры:

- **Фигуры и Расстановка**: Игра включает короля, ферзя, ладьи, слонов, коней и пешек для каждой стороны.
- **Цель Игры**: Захватить короля противника.

Однако, в этой версии добавлены уникальные механики, которые делают игру более динамичной и стратегически глубокой.

---

## Механики Игры

### Туман Войны

Туман войны добавляет элемент неопределённости на поле боя:

- **Открытые и Закрытые Клетки**: Изначально большая часть поля скрыта. Клетки открываются, когда фигуры приближаются.
- **Обновление Тумана**: Каждая клетка, не находящаяся в радиусе 2 клеток от любой фигуры, через 5 ходов становится закрытой.
- **Предварительное Закрытие**: Клетки, которые скоро закроются, отмечаются светло-серым цветом.

### Бонусные Поля

Поле содержит специальные клетки, предоставляющие бонусы:

- **Типы Бонусов**:
  - **Регенерация (regen)**: Восстанавливает 1-2 HP фигуре (кроме короля).
  - **Повышение HP (hp_upgrade)**: Увеличивает максимальный HP фигуры на 1 (кроме короля).
  - **Урон (damage)**: Вычитает 3 HP из фигуры противника без её уничтожения.
  - **Повышение HP Короля (king_hp_upgrade)**: Увеличивает или восстанавливает HP короля.
  - **Добавление Фигуры (add_piece)**: Добавляет новую фигуру рядом с текущей, если возможно.

- **Генерация Бонусов**:
  - Бонусные поля генерируются процедурно при выходе клеток из тумана войны.
  - Шанс появления бонуса составляет **10%** для каждой новой открытой клетки.
  - Тип бонуса определяется следующими вероятностями:
    - Регенерация: 42%
    - Повышение HP: 32%
    - Урон: 20%
    - Повышение HP Короля: 5%
    - Добавление Фигуры: 1%

### Бои и HP Фигур

Каждая фигура имеет **HP (здоровье)**, определяющее её выживаемость:

- **Инициализация HP**:
  - **Король**: 5 HP
  - **Ферзь, Ладья, Слон, Конь**: 3 HP
  - **Пешка**: 1 HP

- **Взаимодействие Фигур**:
  - **Атака**: Когда фигура перемещается на клетку с вражеской фигурой, начинается бой.
  - **Исход Боя**:
    - Если HP атакующего меньше HP защитника: Защитник теряет HP атакующего, атакующий теряет 3 HP (не умирает).
    - Если HP атакующего больше HP защитника: Атакующий теряет HP защитника, защитник теряет 3 HP (не умирает).
    - Если HP равны: Атакующий остаётся с 1 HP, защитник теряет 3 HP (не умирает).

- **Убийство Короля**: Захват короля противника завершает игру.

### Торговцы и Магазин

На поле расположены **торговцы**, представляющие специальные клетки, с которыми можно взаимодействовать:

- **Позиции Торговцев**: Центральная линия по краям поля.
- **Взаимодействие с Торговцем**: При перемещении на клетку торговца открывается **магазин**.
- **Магазин** предлагает следующие улучшения:
  - **Расширить ход**: Увеличивает длину хода для специальных фигур до 5 клеток и для пешек до 2 клеток. Стоимость: 3 монеты.
  - **Увеличить HP**: Увеличивает `max_hp` всех фигур на 3, кроме короля. Стоимость: 3 монеты.
  - **Уменьшить HP врага**: Вычитает 3 HP у всех фигур противника без их уничтожения. Если HP противника меньше 3, устанавливает HP на 1. Стоимость: 3 монеты.
  - **Проклятие**: Уменьшает вероятность появления бонусов у противника `regen` и `hp_upgrade` на 10% каждая. Стоимость: 3 монеты.

---

## Механика Времени

**Время на ход** добавляет дополнительное давление и стратегию в игру:

- **Лимит Времени**: Каждый игрок имеет **2 минуты** на свой ход.
- **Отсчёт Времени**:
  - Таймер отображается в правом нижнем углу.
  - При истечении времени, таймер становится красным.
- **Переполнение Времени**:
  - **Первый пропуск**: Таймер становится красным.
  - **Второй пропуск**: Игрок автоматически проигрывает.
- **Переключение Хода**: После каждого хода время сбрасывается для следующего игрока.

---

## Процедурная Генерация Бонусов

Бонусные поля генерируются динамически, делая каждую игру уникальной:

- **Когда Генерируются Бонусы**:
  - При выходе клетки из тумана войны, с вероятностью **10%** может появиться бонусное поле.

- **Тип Бонуса**:
  - Тип бонуса выбирается на основе текущих вероятностей.
  - После **100 ходов**, вероятность появления бонусов типа "урон" (**damage**) постепенно увеличивается до **50%**, делая игру более опасной.

---

## Баланс Фигур

Для поддержания баланса и динамики игры, движение некоторых фигур было изменено:

- **Ферзь и Ладья**:
  - **Ранее**: Могли перемещаться до **5 клеток** за ход.
  - **Сейчас**: Могут перемещаться до **3 клеток** за ход.

Это изменение делает игру более стратегичной, ограничивая возможности мощных фигур и стимулируя разнообразие тактик.

---

## Обновления и Изменения

### Версия 1.1.1

1. **Добавление Магазина и Монет**:
   - **Магазин**: Теперь доступен при взаимодействии с торговцами на поле. Магазин предлагает различные улучшения за монеты.
   - **Монеты**: Появляются на поле с шансом **0.1%**, становясь более ценными и редкими.
   
2. **Исправление Механики Товара "Уменьшить HP врага"**:
   - Теперь при покупке этого бонуса у всех фигур противника вычитается **3 HP**, но фигуры не умирают.
   - Если HP противника меньше 3, устанавливается **1 HP**.

3. **Улучшение Баланса и Механик**:
   - **Шанс генерации монет** снижен до **0.1%**, уменьшая их количество и повышая ценность.
   - **Удалено отображение вероятностей** генерации бонусов и монет из интерфейса игры, упрощая визуальное восприятие.

4. **Прочие Улучшения**:
   - Оптимизация интерфейса магазина для улучшения взаимодействия с пользователем.
   - Устранение багов, связанных с переходом ходов после применения бонусов.

Спасибо за внимание и приятной игры в **Шахматы с Открытым Миром 1.1.1**!

---
